package enotebooksystem.enotebookbrowser;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import enotebooksystem.enotebook.Enotebook;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: </p>
 * <p>Ж: </p>
 * @author ɓ ~
 * @version 1.0
 */

public class BrowserFrame extends JFrame {
  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  /*
  JToolBar jToolBar = new JToolBar();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  JButton jButton3 = new JButton();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  */
  JLabel statusBar = new JLabel();
  BorderLayout browser_borderLayout = new BorderLayout();
  JPanel mainPanel = new JPanel();
  JScrollPane editorScrollPane = new JScrollPane();
  BorderLayout mainPanel_borderLayout = new BorderLayout();
  public static JEditorPane jEditorPane;
  JPanel addressPanel = new JPanel();
  JLabel addressLabel = new JLabel();
  public static JTextField addressField = new JTextField();

  BrowserActionListener browserActionListener = new BrowserActionListener(this);
  BrowserHyperlinkLisetner browserHyperlinkLisetner = new BrowserHyperlinkLisetner(this);
  String homePage = "file:///D:/e-Notebook/windows/archive/html/0000/Department of Computer Science.htm";//"http://www.cs.takushoku-u.ac.jp/English/index.html";

  public Enotebook enotebook;
  BorderLayout borderLayout1 = new BorderLayout();

  ScreenCapture sc;
  enotebooksystem.enotebook.MainFrame editorFrame;
  enotebooksystem.enotebook.MakeFile mkf;
  //t[̃rh
  public BrowserFrame(Enotebook enote) {
    enotebook = enote;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //R|[lg̏
  private void jbInit() throws Exception  {
    jEditorPane = new JEditorPane();
    sc = new ScreenCapture(this);
    mkf = new enotebooksystem.enotebook.MakeFile();
    //image1 = new ImageIcon(enotebooksystem.enotebookbrowser.BrowserFrame.class.getResource("openFile.png"));
    //image2 = new ImageIcon(enotebooksystem.enotebookbrowser.BrowserFrame.class.getResource("closeFile.png"));
    //image3 = new ImageIcon(enotebooksystem.enotebookbrowser.BrowserFrame.class.getResource("help.png"));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(browser_borderLayout);
    this.setSize(new Dimension(640, 480));
    this.setTitle("e-Notebook Browser");
    statusBar.setText(" ");
    jMenuFile.setText("t@C");
    jMenuFileExit.setText("I");
    jMenuFileExit.addActionListener(new BrowserFrame_jMenuFileExit_ActionAdapter(this));
    jMenuHelp.setText("wv");
    jMenuHelpAbout.setText("o[W");
    jMenuHelpAbout.addActionListener(new BrowserFrame_jMenuHelpAbout_ActionAdapter(this));
    /*
    jButton1.setIcon(image1);
    jButton1.setToolTipText("t@CJ");
    jButton2.setIcon(image2);
    jButton2.setToolTipText("t@C");
    jButton3.setIcon(image3);
    jButton3.setToolTipText("wv");
    */
    mainPanel.setLayout(mainPanel_borderLayout);
    addressField.addActionListener(browserActionListener);
    addressLabel.setText("URL : ");
    addressField.setScrollOffset(1);
    addressField.setText(homePage);
    jEditorPane.setEditable(false);
    jEditorPane.addHyperlinkListener(browserHyperlinkLisetner);
    //jToolBar.add(jButton1);
    //jToolBar.add(jButton2);
    //jToolBar.add(jButton3);
    addressPanel.setLayout(borderLayout1);
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    this.setJMenuBar(jMenuBar1);
    //contentPane.add(jToolBar, BorderLayout.NORTH);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    contentPane.add(mainPanel, BorderLayout.CENTER);
    mainPanel.add(editorScrollPane,  BorderLayout.CENTER);
    mainPanel.add(addressPanel, BorderLayout.NORTH);
    addressPanel.add(addressLabel, BorderLayout.WEST);
    addressPanel.add(addressField, BorderLayout.CENTER);
    editorScrollPane.getViewport().add(jEditorPane, null);
  }

  public void connectToFrame(enotebooksystem.enotebook.MainFrame fr){
    this.editorFrame = fr;
  }

  public void mySetPage(String newPage){
    try{
      jEditorPane.setPage(newPage);
      mkf.makeFile(enotebooksystem.enotebook.MainFrame.presentPath,enotebooksystem.enotebook.MainFrame.newImageName);
      //sc.capture();
      sc.captureFrame();
      sc.saveImage(new File(enotebooksystem.enotebook.MainFrame.imagePath+enotebooksystem.enotebook.MainFrame.newImageName+".jpg"));
      int num = Integer.parseInt(enotebooksystem.enotebook.MainFrame.newImageName);
      num += 1;
      String numName = Integer.toString(num);
      int numlen = numName.length();
      if(numlen == 1){
        enotebooksystem.enotebook.MainFrame.newImageName = "000"+numName;
      }else if(numlen == 2){
        enotebooksystem.enotebook.MainFrame.newImageName = "00"+numName;
      }else if(numlen == 3){
        enotebooksystem.enotebook.MainFrame.newImageName = "0"+numName;
      }else if(numlen == 4){
        enotebooksystem.enotebook.MainFrame.newImageName = numName;
      }else{
        System.out.println("err over image number");
        System.exit(0);
      }
    }catch(IOException e){
      e.printStackTrace();
    }
  }

  //[t@C|I]
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    //System.exit(0);
    this.dispose();
  }
  //[wv|o[W]
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    BrowserFrame_AboutBox dlg = new BrowserFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }
  //EBhEꂽƂɏI悤ɃI[o[Ch
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }
}

class BrowserFrame_jMenuFileExit_ActionAdapter implements ActionListener {
  BrowserFrame adaptee;

  BrowserFrame_jMenuFileExit_ActionAdapter(BrowserFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class BrowserFrame_jMenuHelpAbout_ActionAdapter implements ActionListener {
  BrowserFrame adaptee;

  BrowserFrame_jMenuHelpAbout_ActionAdapter(BrowserFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}