package enotebooksystem.enotebook;

import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.*;

/**
 * <p>BwHwHw |JEX، </p>
 * @author ɓ ~
 * @version 1.0
 */


public class ChangeTagContents  extends DefaultHandler{
  MainFrame fr;
  boolean flag1 = true;
  boolean flag2 = false;
  boolean flag3 = false;
  String tagName;

  public ChangeTagContents(MainFrame frame) {
    fr = frame;
  }

  public void changeTagContents(String path,String name){
    tagName = name;
    try {
      // t@Ng쐬
      SAXParserFactory saxParserFactory = SAXParserFactory.newInstance();
      // XML
      saxParserFactory.setValidating(true);
      // XMLt@Cǂݍ
      BufferedInputStream input = new BufferedInputStream(new FileInputStream(new File(path)));//default.xml")));
      // SAXp[T[擾
      SAXParser saxParser = saxParserFactory.newSAXParser();
      InputSource inputSource = new InputSource(input);
      // XMLt@C[h
      saxParser.parse(inputSource, this);
    } catch (Exception e) {
      System.err.println("ChangeTagContents : "+e);
      e.printStackTrace();
    }

  }
  // ̊Jnʒm
  public void startDocument() {
    flag1 = true;
    flag2 = false;
    flag3 = false;
    fr.str1 = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+"\n";
    System.out.println("startDocument ChangeTagContents");
    //System.out.println("start document flag1 = "+flag1 +", flag2 = "+ flag2 + ", flag3 = "+ flag3);
  }

  public void startElement(String namespaceURI,
                           String localName,
                           String qName,
                           Attributes atts) {
    //System.out.println("Start element:namespaceURI = " + namespaceURI);
    //System.out.println("name = " + localName + " qName = " + qName);
    //System.out.println("localName: " + localName);
    //System.out.println("attributes: " + atts);

    if(qName.equals(tagName)){
      fr.str1 += "<"+qName+">";
      flag1 = false;
      flag2 = true;
      //System.out.println("start element <document> flag1 = "+flag1 +", flag2 = "+ flag2 + ", flag3 = "+ flag3);
    }else{
      //System.out.println("start element flag1 = "+flag1 +", flag2 = "+ flag2 + ", flag3 = "+ flag3);
    }

    if(atts.getQName(0) == null){//^O
      if(flag1 == true){
        fr.str1 += "<"+qName+">";
      }else if(flag3 == true){
        fr.str3 += "<"+qName+">";
      }

    }else{//^Oɑꍇ
      int l = atts.getLength();
      if (l > 0){

        if(flag1 == true){
          //System.out.println("Attr");
          fr.str1 += "<"+qName+" ";
          for (int i = 0; i < l; i++){
            fr.str1 += atts.getQName(i)+"=\""+atts.getValue(i)+"\" ";
            String Local = atts.getLocalName(i);
            String QName = atts.getQName(i);
            String pName = atts.getValue(i);
            //System.out.println("attributes : LocalName = "+Local+", QName = " + QName + ", pName = " + pName);
          }
          fr.str1 += ">";

        }else if(flag3 == true){
          fr.str3 += "<"+qName+" ";
          for (int i = 0; i < l; i++){
            fr.str3 += atts.getQName(i)+"=\""+atts.getValue(i)+"\" ";
            String Local = atts.getLocalName(i);
            String QName = atts.getQName(i);
            String pName = atts.getValue(i);
            //System.out.println("attributes : LocalName = "+Local+", QName = " + QName + ", pName = " + pName);
          }
          fr.str3 += ">";
        }
      }
    }
  }

  // vf̕f[^̒ʒm
  public void characters(char[] ch, int start, int length) {
    if(flag1 == true){
      fr.str1 += new String(ch,start,length);
      //System.out.println("characters flag1 = "+flag1 +", flag2 = "+ flag2 + ", flag3 = "+ flag3);
    }else if(flag2 == true){
      //System.out.println("characters : " + new String(ch, start, length));
      fr.strbuff += new String(ch,start,length);
      fr.str2 += new String(ch,start,length);
      //System.out.println("characters flag1 = "+flag1 +", flag2 = "+ flag2 + ", flag3 = "+ flag3);
      //flag2 = false;

      //System.out.println("start,length: " + start +" , " + length + " , ch[start]:" + ch[start]);
    }else if(flag3 == true){
      fr.str3 += new String(ch,start,length);
      //System.out.println("characters flag1 = "+flag1 +", flag2 = "+ flag2 + ", flag3 = "+ flag3);
    }else{
      //System.out.println(new String(ch,start,length));
    }

  }

  // vf̏Iʒm
  public void endElement(String namespaceURI,
                         String localName,
                         String qName) {

    if(qName.equals(tagName)){
      flag2 = false;
      flag3 = true;
    }
    if(flag1 == true){
      fr.str1 += "</"+qName+">";
    }else if(flag3 == true){
      fr.str3 += "</"+qName+">";
    }


    //System.out.println("endElement namespaceURI: " + namespaceURI);
    //System.out.println("endElement localName: " + localName);
    //System.out.println("endElement qName: " + qName);

  }

  // ̏Iʒm
  public void endDocument() {
    //System.out.println("endDocument");
    //System.out.println("fr.strbuff\n"+fr.strbuff);
    //System.out.println("fr.str1\n"+fr.str1);
    //System.out.println("fr.str2\n"+fr.str2);
    //System.out.println("fr.str3\n"+fr.str3);

  }


}